import re, HTMLParser

header = """
from sanitizer import Sanitizer
import unittest, re

class TestSanitizer(unittest.TestCase):

    def setUp(self):
        self.sanitizer = Sanitizer()

    def output(self, id, html, safehtml):
        print "=========== Test %s ===============\\n" %id
        print ">>>\\n%s" %html
        print "<<<\\n%s" %safehtml

    def containsXSS(self,html):
        if re.search('XSS', html):
            return True
        else:
            return False

"""

footer = """
if __name__ == '__main__':
    unittest.main()
"""

count = 0
op = open('xss_unit_tests.py','w')
op.write(header)

def escape(string):
    return re.sub('"','\\"',string)

print escape('"this" "is" a "test"')
h = HTMLParser.HTMLParser()

for line in open('hacker_test_suite'):
    s = re.search('TEXTAREA.*?>(.*?)</TEXTAREA', line)
    if s:

        if count == 49:
            count += 1
            continue

        html = s.group(1)
        html = h.unescape(html)

        op.write('    def test_xss_%s(self):\n' %count)
        op.write('        html = """%s"""\n' %escape(html))
        op.write('        safehtml = self.sanitizer.sanitizeHtml(html)\n')
        op.write('        self.output(%s, html,safehtml)\n' %count)
        op.write('        self.assertFalse(self.containsXSS(html))\n\n')

        count += 1

op.write(footer)

    

